Bug 1102667 - boost-python has no linkage-to or dependency on libpython
Summary: boost-python has no linkage-to or dependency on libpython
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: boost
Version: 20
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Petr Machata
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1101626 1302120
TreeView+ depends on / blocked
 
Reported: 2014-05-29 12:18 UTC by Rex Dieter
Modified: 2016-01-26 20:30 UTC (History)
6 users (show)

Fixed In Version: boost-1.54.0-12.fc20
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1302120 (view as bug list)
Environment:
Last Closed: 2015-01-26 02:39:25 UTC
Type: Bug


Attachments (Terms of Use)
Respect ABI flags of libpython (2.44 KB, patch)
2014-05-29 18:15 UTC, Petr Machata
no flags Details | Diff
Spec file fix (1.68 KB, patch)
2015-01-09 20:46 UTC, Petr Machata
no flags Details | Diff

Description Rex Dieter 2014-05-29 12:18:59 UTC
It seems that boost-python has no linkage-to or dependency on libpython.  I discovered this investigating possibly related bug #1101626

The last boost-python that links against libpython appears to be boost-python-1.48.0 (I inspected http://koji.fedoraproject.org/koji/rpminfo?rpmID=3167510 )

$ rpm -q boost-python
boost-python-1.54.0-9.fc20.x86_64

$ rpm -qR boost-python | grep py
(empty)

$ ldd -r /usr/lib64/libboost_python.so.1.54.0 
        linux-vdso.so.1 =>  (0x00007fff06d59000)
        libutil.so.1 => /lib64/libutil.so.1 (0x00007f5102adc000)
        libpthread.so.0 => /lib64/libpthread.so.0 (0x00007f51028bf000)
        libdl.so.2 => /lib64/libdl.so.2 (0x00007f51026ba000)
        librt.so.1 => /lib64/librt.so.1 (0x00007f51024b2000)
        libstdc++.so.6 => /lib64/libstdc++.so.6 (0x00007f51021aa000)
        libm.so.6 => /lib64/libm.so.6 (0x00007f5101ea2000)
        libgcc_s.so.1 => /lib64/libgcc_s.so.1 (0x00007f5101c8c000)
        libc.so.6 => /lib64/libc.so.6 (0x00007f51018cd000)
        /lib64/ld-linux-x86-64.so.2 (0x00007f5102f7b000)
undefined symbol: PyExc_ImportError     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyProperty_Type       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyExc_StopIteration   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyBool_Type   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyClass_Type  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyExc_ValueError      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyList_Type   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: _Py_NotImplementedStruct      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyExc_TypeError       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_Type   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyInt_Type    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyComplex_Type        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyExc_ReferenceError  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyModule_Type (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyBaseObject_Type     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyFloat_Type  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyExc_IndexError      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyUnicode_Type        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyTuple_Type  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyExc_RuntimeError    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyType_Type   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyMethod_Type (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyStaticMethod_Type   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyLong_Type   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: _Py_NoneStruct        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyExc_OverflowError   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyExc_AttributeError  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyCFunction_Type      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyString_Type (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyType_GenericAlloc   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyList_Insert (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyString_InternFromString     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyString_AsString     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyUnicodeUCS4_FromEncodedObject       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyImport_Import       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceRshift        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_CallMethod   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyIter_Next   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Remainder    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: Py_InitModule4_64     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyType_Ready  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: _PyEval_SliceIndex    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyFile_AsFile (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyLong_FromUnsignedLong       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyMem_Free    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceXor   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceOr    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyBool_FromLong       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_Items  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceRemainder     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_NoMemory        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyComplex_ImagAsDouble        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_IsTrue       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Lshift       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceMultiply      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: _PyObject_New (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_GetItem      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyString_FromStringAndSize    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceLshift        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyString_Size (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_Update (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyComplex_RealAsDouble        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_Format  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_And  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyUnicodeUCS4_AsWideChar      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceAdd   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_GetAttr      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_ExceptionMatches        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_Occurred        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_Copy   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyArg_ParseTupleAndKeywords   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Divide       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyEval_GetGlobals     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_Keys   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_SetObject       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Multiply     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyRun_FileExFlags     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_Size (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyString_FromString   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyString_FromFormat   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceAnd   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyInt_FromLong        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_Size   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_GetItem        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_SetItem      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyInt_AsLong  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_RichCompare  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyCFunction_NewEx     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_Values (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Rshift       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyStaticMethod_New    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyType_IsSubtype      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Add  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyList_Sort   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PySequence_DelSlice   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_WarnEx  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Xor  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_ClearWeakRefs        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Subtract     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PySlice_New   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_GetAttrString        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_IsInstance   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyRun_StringFlags     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_SetAttrString        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyWeakref_NewRef      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_NewException    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyList_Append (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_SetAttr      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_GetItemString  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceDivide        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyLong_AsLongLong     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyLong_AsUnsignedLongLong     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_Or   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_DelItem      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyNumber_InPlaceSubtract      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyMethod_New  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyEval_CallFunction   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PySequence_GetSlice   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyTuple_Size  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyImport_ImportModule (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_Clear   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyTuple_New   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyTuple_GetItem       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyErr_SetString       (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyObject_CallFunction (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyList_Reverse        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyFile_FromString     (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: _PyType_Lookup        (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyList_New    (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyMem_Malloc  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyCallable_Check      (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_Clear  (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PySequence_SetSlice   (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyLong_AsUnsignedLong (/usr/lib64/libboost_python.so.1.54.0)
undefined symbol: PyDict_New    (/usr/lib64/libboost_python.so.1.54.0)

Comment 1 Rex Dieter 2014-05-29 12:33:33 UTC
Looks like this may be on purpose,
https://svn.boost.org/trac/boost/ticket/2615

Comment 2 Petr Machata 2014-05-29 18:15:40 UTC
Created attachment 900478 [details]
Respect ABI flags of libpython

Filed https://svn.boost.org/trac/boost/ticket/10079 for this.

We will need at least the patch that I'm attaching in addition to the patchled in the referenced bug, as currently on Fedora we have libpython3.2m.so, not libpython3.2.so.  I will possibly open a separate bug to track this depending on how the referenced bug evolves.

Comment 3 Petr Machata 2015-01-09 20:46:43 UTC
Created attachment 978385 [details]
Spec file fix

The following is another upstream ticket somewhat tangential to this issue (in that the Boost.Python test suite fails, although it likely fails irrespective of whether we apply the DT_NEEDED patches):
  https://svn.boost.org/trac/boost/ticket/10923

The patches make the test fail because then -lpythonXY is brought in, and exec test fails, because it requests static linking, and we don't ship static -lpython in Fedora.  exec-dynamic works though, and I'm somewhat inclined to dismiss this failure.

Comment 4 Fedora Update System 2015-01-14 01:19:07 UTC
boost-1.55.0-8.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/boost-1.55.0-8.fc21

Comment 5 Fedora Update System 2015-01-14 01:30:17 UTC
boost-1.54.0-12.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/boost-1.54.0-12.fc20

Comment 6 Fedora Update System 2015-01-14 23:57:33 UTC
Package boost-1.54.0-12.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing boost-1.54.0-12.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-0713/boost-1.54.0-12.fc20
then log in and leave karma (feedback).

Comment 7 Fedora Update System 2015-01-20 21:03:22 UTC
boost-1.55.0-8.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2015-01-26 02:39:25 UTC
boost-1.54.0-12.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Maurizio Paolini 2015-03-16 16:21:56 UTC
It seems there are still linkage problems.  As requested in the
discussion of bug report https://bugs.kde.org/show_bug.cgi?id=335965 (reopened)
I am posting the following output (32 bit architecture):

$ rpm -q boost-python
boost-python-1.55.0-8.fc21.i686

$ ldd -r  /usr/lib/python2.7/lib-dynload/math.so
        linux-gate.so.1 =>  (0xb7800000)
        libpthread.so.0 => /lib/libpthread.so.0 (0xb77b3000)
        libc.so.6 => /lib/libc.so.6 (0xb75e6000)
        /lib/ld-linux.so.2 (0x49ceb000)
undefined symbol: PyFloat_Type  (/usr/lib/python2.7/lib-dynload/math.so)
undefined symbol: sinh  (/usr/lib/python2.7/lib-dynload/math.so)
undefined symbol: ceil  (/usr/lib/python2.7/lib-dynload/math.so)
[...]
undefined symbol: log1p (/usr/lib/python2.7/lib-dynload/math.so)
undefined symbol: PyMem_Malloc  (/usr/lib/python2.7/lib-dynload/math.so)

for a total of 64 undefined symbols

--------------

The originating problem was trying to use mathematical functions in a python script in kig, that is still impossible.  A workaround in Fedora 21 is

$ LD_PRELOAD=/usr/lib/libpython2.7.so.1.0 kig --nofork


Note You need to log in before you can comment on or make changes to this bug.